#!/usr/bin/env python3
import bz2
import lzma
import os
import random
import sys
import time

def readFile(file_path):

    if file_path.endswith('.bz2'):
        f = bz2.open(file_path)
        is_compressed = True
    elif file_path.endswith('.xz'):
        f = lzma.open(file_path)
        is_compressed = True
    else:
        f = open(file_path)
        is_compressed = False

    for line in f:
        if is_compressed:
            yield line.decode()
        else:
            yield line

    f.close()

if int(sys.argv[1]) == -1:
    data_list = ['heart_scale', 'rcv1_test', 'kdda', 'higgs', 'url']
elif int(sys.argv[1]) == 0:
    data_list = ['heart_scale', 'rcv1_test', 'kdda', 'higgs', 'url']
else:
    data_list = ['heart_scale', 'kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'splice_site_t_0_1', 'rcv1_test']

data_url_dict = {\
'heart_scale':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/heart_scale',\
'avazu-app':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/avazu-app.bz2',\
'criteo':'https://s3-us-west-2.amazonaws.com/criteo-public-svm-data/criteo.kaggle2014.svm.tar.gz',\
'eps':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/epsilon_normalized.bz2', \
'higgs':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/HIGGS.bz2', \
'kdda':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/kdda.bz2',\
'kdd12':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/kdd12.bz2', \
'rcv1_test':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/rcv1_test.binary.bz2', \
'splice_site_t_0_1':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/splice_site.t.xz',\
'url':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/url_combined.bz2', \
'web_trigram':'https://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/webspam_wc_normalized_trigram.svm.bz2',\
}

for data in data_list:
    if data in data_url_dict:
        data_url = data_url_dict[data]
        os.system('wget {0}'.format(data_url))

        if data == 'splice_site_t_0_1':
            random.seed(0)
            START = time.time()
            with lzma.open('splice_site.t.0.1.xz', 'wb') as f:
                datasetPath = './splice_site.t.xz'
                for i, line in enumerate(lzma.open(datasetPath), start=1):
                    if i % 10000 == 0:
                        now = time.time()
                        print(i, now - START)

                    if random.random() < 0.1:
                        f.write(line)
            os.system('unxz splice_site.t.0.1.xz')
        elif data_url.endswith('.bz2'):
            os.system('bunzip2 {0}'.format(data_url.split('/')[-1]))
        elif data_url.endswith('.tar.gz'):
            os.system('tar -zxvf {0}'.format(data_url.split('/')[-1]))
        else:
            continue

if 'rcv1_test' in data_list:
    os.system('mv rcv1_test.binary rcv1_test')
if 'web_trigram' in data_list:
    os.system('mv webspam_wc_normalized_trigram.svm webspam_wc_normalized_trigram')
if 'criteo' in data_list:
    os.system('mv criteo.kaggle2014.train.svm criteo.tr.svm')
