#!/usr/bin/env python3

FILE_PATH_TEMPLATE = './bcdn_supp_log/{data}.bcdn-atomic.a2.s0.t{thread}.b{bundle_size}'

def parse_line(line):
    if line.startswith('*'):
        line = line[2:]
    if not line.startswith('iter'):
        return None

    tokens = line.strip().split()

    d = {}
    for i, token in enumerate(tokens):
        if i % 2 == 0:
            key = token
        else:
            d[key] = float(token)

    d['iter'] += 1

    return d

def parse_file(data, thread, bundle_size, target_obj):
    filepath = FILE_PATH_TEMPLATE.format(data=data, thread=thread, bundle_size=bundle_size)
    for line in open(filepath):
        d = parse_line(line)
        if d is None:
            continue
        if d['f'] < target_obj:
            cal_d_time = d['time'] - d['linesearch_time'] - d['memset_time']
            token_list = [bundle_size, d['iter'], d['time'], d['memset_time'], cal_d_time, d['linesearch_time']]
            token_list = map(int, token_list)
            token_list = map(str, token_list)
            print(' & '.join(token_list) + '\\\\')
            break

print("=====kdda=====")
for bundle_size in [5000, 10000, 20000, 29500, 50000]:
    parse_file('kdda', 1, bundle_size, 2246845) 

print("=====url=====")
for bundle_size in [1000, 5000, 10000, 50000, 100000, 500000]:
    parse_file('url', 1, bundle_size, 72698) 

#print("=====higgs=====")
#for bundle_size in [1, 2, 4, 8, 16, 24, 28]:
#    parse_file('higgs', 1, bundle_size, 7148298) 
