#!/usr/bin/env python3

import subprocess

cores_list_1 = [1, 8]
cores_list_2 = [4, 2]
data_list = ['eps', 'web_trigram', 'split_site_t_0_1', 'avazu-app', 'criteo', 'url']

datas_path_dict = {\
'eps':'/data/epsilon_normalized', \
'web_trigram':'/data/webspam_wc_normalized_trigram',\
'split_site_t_0_1':'/data/split_site.t.0.1'
'criteo':'/data/criteo', \
'url':'/data/url_combined', \
'avazu-app':'/data/avazu-app',\
}

method_path_dict = {\
'cddual':'./codes/liblinear-2.11-omp/'
}

methods_list = ['cddual']
e = 0.01
m_list = [0]

def run(cmd):
    print(cmd)
    subprocess.call(cmd, shell=True)

log_dir_suffix = 'cddual.speedup.log'

for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for m in m_list:
        for core in cores_list_1:
            for method in methods_list:
                if method == 'cddual':
                    cmd = '{method_dir}/train -s 1 -m {m} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}-m{m}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, m = m)
                else:
                    continue
                run(cmd)
for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for m in m_list:
        for core in cores_list_2:
            for method in methods_list:
                if method == 'cddual':
                    cmd = '{method_dir}/train -s 1 -m {m} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}-m{m}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, m = m)
                else:
                    continue
                run(cmd)
