#!/usr/bin/env python3

import subprocess

cores_list_1 = [1, 8]
cores_list_2 = [4, 2]
#data_list = ['kdda', 'kdd12', 'eps', 'avazu-app', 'higgs', 'url', 'criteo', 'web_trigram', 'split_site_t_0_1', 'rcv1_test']
data_list = ['rcv1_test']

datas_path_dict = {\
'criteo':'./data/criteo', \
'rcv1_test':'./data/rcv1_test', \
'yk':'./data/leisure', \
'eps':'./data/epsilon_normalized', \
'higgs':'./data/HIGGS', \
'kdd12':'./data/kdd12', \
'url':'./data/url_combined', \
'web_trigram':'./data/webspam_wc_normalized_trigram',\
'avazu-app':'./data/avazu-app',\
'kdda':'./data/kdda',\
'split_site_t_0_1':'./data/split_site.t.0.1'
}

method_path_dict = {\
'cdn_svm_nonshrink':'../code/cdn/npcd-nonshrink',\
'cdn_svm':'../code/cdn/npcd',\
'shotgun_svm':'../code/cdn/liblinear-2.11-shotgun/',
'shotgun_svm_long':'../code/cdn/liblinear-2.11-shotgun-long/',
'bcdn_svm':'../code/cdn/ParallelCDN-master',
'cdn_lr_nonshrink':'../code/cdn/liblinear-1.7-omp-nonshrink/',
'cdn_lr':'../code/cdn/liblinear-1.7-omp',
'bcdn_lr':'../code/cdn/ParallelCDN-master',
'shotgun_lr':'../code/cdn/liblinear-1.7-shotgun',
'shotgun_lr_long':'../code/cdn/liblinear-1.7-shotgun-long',
}

method_max_iter_dict = {\
'cdn_svm':200,\
'cdn_lr':100,\
'cdn_svm_original_swap':200,\
'cdn_lr_original_swap':100,\
'newglmnet':50,\
}

#methods_list = ['cdn_svm_original_swap', 'cdn_lr_original_swap']
methods_list = ['cdn_svm', 'cdn_lr']
e = 0.01

def run(cmd):
    print(cmd)
    subprocess.call(cmd, shell=True)

log_dir_suffix = 'no.decay.cdn.shrink-vs-nonshrink.log'
h_list = [0, 1]

for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for core in cores_list_1:
        for method in methods_list:
            for h in h_list:
                if method == 'cdn_svm' or method == 'cdn_svm_original_swap':
                    cmd = '{method_dir}/train -s 5 -i {i} -h {h} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, i = method_max_iter_dict[method])
                elif method == 'cdn_lr' or method == 'cdn_lr_original_swap':
                    cmd = '{method_dir}/train -s 6 -h {h} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, i = method_max_iter_dict[method])
                else:
                    continue
                run(cmd)

for data in data_list:
    run('mkdir -p {data}.{suffix}'.format(data=data, suffix=log_dir_suffix))
    for core in cores_list_2:
        for method in methods_list:
            for h in h_list:
                if method == 'cdn_svm' or method == 'cdn_svm_original_swap':
                    cmd = '{method_dir}/train -s 5 -i {i} -h {h} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, i = method_max_iter_dict[method])
                elif method == 'cdn_lr' or method == 'cdn_lr_original_swap':
                    cmd = '{method_dir}/train -s 6 -h {h} -c {c} -t {num_threads} {data_path} > {data}.{suffix}/{method}.{h}.{core}.log'.format(data_path=datas_path_dict[data], c=1, data=data, core=core, method_dir=method_path_dict[method], method=method, num_threads=core, suffix=log_dir_suffix, h = h, i = method_max_iter_dict[method])
                else:
                    continue
                run(cmd)
